function stringStartsWithValue(string, value) {
    return string.indexOf(value) === 0;
}

function isJsonString(text){
    if (typeof text !== "string"){
        return false;
    }
    try{
        JSON.parse(text);
        return true;
    }
    catch (error){
        return false;
    }
}

function setDifference (L1, L2){

    // compute difference = L1 - L2
    var difference = [];
    for( var i=0; i<L1.length; i++ ) {
        if (L2.indexOf(L1[i]) == -1){
           difference = difference.concat(L1[i]);
        }
    }
    return difference
}

function mapDescriptionToIdentificationForTpFieldsOld(dataObject){
    var resultObject = {};
    console.log("mapDescriptionToIdentificationForTpProps()");
    for (var j in dataObject.fields) {
        var field = dataObject.fields[j];
        var href = dataObject.fields[j].definition.href;
        tpApiRequest(href, 'GET', 'json', 'application/json', null,
            function (response) {
                resultObject[field.definition.title] = response.document_field_definition.identification;
                //console.log("field.definition.title: " + field.definition.title  + "  ident: " + response.document_field_definition.identification);
            }, 2
        );
    }
    //console.log("resultObject: \n" + JSON.stringify(resultObject, false, 2));
    return resultObject;
}


function mapDescriptionToIdentificationForTpFields(documentTypeHref){

    var url = documentTypeHref + "/field_definitions/?embedded=1";

    var resultObject = {};
  
    tpApiRequest(url, 'GET', 'json', 'application/json', null,
        function (response) {
            for (var i=0; i < response.field_definitions.length; i++){
                resultObject[response.field_definitions[i].name] = response.field_definitions[i].identification;
            }
        }, 2
    );
    return resultObject;
}


async function buildBimdocnumRevisionVersionObjectForParialModelsInDesite(){

    var BimdocnumRevVersObject = {};
    var tpColonNameForBIM_DOC_ID = "";
    var tpColonNameForVersion = "";

    for (var tpColonPropName in _config.ProjectDescription.PartialModels.PropertiesForTransferToDESITE) {
        var prop = _config.ProjectDescription.PartialModels.PropertiesForTransferToDESITE[tpColonPropName];
        if (prop == "bim_doc_id") tpColonNameForBIM_DOC_ID = tpColonPropName;
        //if (prop == "Revision") var tpColonNameForRevision = tpColonPropName;
        if (prop == "Version") tpColonNameForVersion = tpColonPropName;
    }
    if (tpColonNameForBIM_DOC_ID == "" || tpColonNameForVersion == "") return BimdocnumRevVersObject;

    
    /* desiteAPI.itClear();
    desiteAPI.itByFilter('cpName', 'xs:string', "*Model*");
    var pmInDesiteIdList1 = desiteAPI.strToIdList(desiteAPI.itGetObjectList()); 
    console.log("pmInDesiteIdList1: \n" + JSON.stringify(pmInDesiteIdList1)); */
    
    /* var pmInDesiteIdList2 = desiteAPI.getModelListByDomain("geometry");
    console.log("pmInDesiteIdList2: \n" + JSON.stringify(pmInDesiteIdList2));  */

    var pmInDesiteRootIdList = await desiteAPI.getRootNodeListByDomain("geometry");
    //console.log("pmInDesiteRootIdList: \n" + JSON.stringify(pmInDesiteRootIdList)); 

    for (var i = 0; i < pmInDesiteRootIdList.length; i++) {
        var bimDocId = await desiteAPI.getPropertyValue(pmInDesiteRootIdList[i], tpColonNameForBIM_DOC_ID, 'xs:string');
        if(bimDocId == null) continue;
        var bimDocId_splitting = bimDocId.split("-");
        if (bimDocId_splitting.length < 3) continue;
        var bimDocNumber = bimDocId_splitting[0] + "-" + bimDocId_splitting[1];
        var bimDocRev = bimDocId_splitting[2]; // == desiteAPI.getPropertyValue(pmInDesiteRootIdList[i], tpColonNameForRevision, 'xs:string');
        var bimDocVersion = await desiteAPI.getPropertyValue(pmInDesiteRootIdList[i], tpColonNameForVersion, 'xs:string');
        if (bimDocVersion == null) continue;
        if (BimdocnumRevVersObject[bimDocNumber] == null) {
            BimdocnumRevVersObject[bimDocNumber] = {};
            BimdocnumRevVersObject[bimDocNumber][bimDocRev] = [bimDocVersion];
        } else if (BimdocnumRevVersObject[bimDocNumber][bimDocRev] == null) {
            BimdocnumRevVersObject[bimDocNumber][bimDocRev] = [bimDocVersion];
        } else if (BimdocnumRevVersObject[bimDocNumber][bimDocRev].indexOf(bimDocVersion) == -1) {
            BimdocnumRevVersObject[bimDocNumber][bimDocRev].push(bimDocVersion);
        }
    }
    //console.log("BimdocnumRevVersObject:");
    //console.log(JSON.stringify(BimdocnumRevVersObject, false, 2));
    return BimdocnumRevVersObject;
}


function normalizeIdList(idList){
    var retList = [];
    for( var i=0; i<idList.length; i++ ) {
        var d = idList[i].indexOf(":");
        var elem = "";
        if (d != -1){
            elem = idList[i].slice(0,d);
        }else{
            elem = idList[i];
        }
        if(retList.indexOf(elem) == -1) {
            retList.push(elem);
        }
    }
    return retList
}

function debugPrint(text) {

    //$('#debugOutput').append('\n' + text);
    document.getElementById("debugOutput").innerHTML += '\n' + text;
}

function debugClear() {
    document.getElementById("debugOutput").innerHTML = "";
}

function tableClear(tableId) {
    document.getElementById(tableId).innerHTML = "";
}

function setDisplayPropForElement(elementId, displayProp) {

    // displayProp is 'none' or ''

    document.getElementById(elementId).style.display = displayProp;

    var childrenOfElement = document.getElementById(elementId).children;

    for (var j = 0; j < childrenOfElement.length; j++) {
        childrenOfElement[j].style.display = displayProp;
    }
}

function setNumberOfPages() {

    //  console.log('BEGIN setNumberOfPages()');
    _numberOfRowsToShow = _rowNumbersToShow.length;
    //console.log('_numberOfRowsToShow: ' + _numberOfRowsToShow);

    var rest = _numberOfRowsToShow % _pageLength;

    if (rest == 0) {
        _numberOfPages = parseInt(_numberOfRowsToShow / _pageLength);
    } else {
        _numberOfPages = parseInt(_numberOfRowsToShow / _pageLength) + 1;
    }

    //console.log('rest: ' + rest  + '    _numberOfPages: ' + _numberOfPages);
    //console.log('END setNumberOfPages()');
}

function isLineOnPage(lineNumber, pageNumber) {

    if (pageNumber != _numberOfPages) {

        return (_pageLength * (pageNumber - 1) <= lineNumber) && (lineNumber <= _pageLength * pageNumber - 1);
    } else {

        return (_pageLength * (pageNumber - 1) <= lineNumber) && (lineNumber <= _numberOfRowsToShow);
    }
}

function toPreviousPage(tableId) {

    //console.log('BEGIN  toPreviousPage()');
    //console.log('_currentPageNumber := ' +  _currentPageNumber);
    var pageNumber = _currentPageNumber - 1;
    if (pageNumber != 0) {
        _currentPageNumber = pageNumber;
        //console.log('_currentPageNumber := ' +  pageNumber);
        //console.log('CALL buildPage(_currentpageNumber)');
        buildBimdocnumRevisionVersionObjectForParialModelsInDesite().then(
            function(pmNumRevVersObject) {buildPage(tableId, _currentPageNumber, pmNumRevVersObject);} 
        );
    }

    //console.log('END  toPreviousPage()');

}


function toNextPage(tableId) {
    //console.log('BEGIN  toNextPage('+ tableId +')');
    //console.log('_currentPageNumber := ' +  _currentPageNumber);
    var pageNumber = _currentPageNumber + 1;
    if (pageNumber <= _numberOfPages) {
        _currentPageNumber = pageNumber;
        //console.log('_currentPageNumber := ' +  pageNumber);
        //console.log('CALL buildPage(tableId, _currentpageNumber) tableId: ' + tableId);
        buildBimdocnumRevisionVersionObjectForParialModelsInDesite().then(
            function(pmNumRevVersObject) {buildPage(tableId, _currentPageNumber, pmNumRevVersObject);} 
        );
    }
    //console.log('END  toNextPage('+ tableId +')');
}

function buildPieceOfRowForTableVP(vpNumber, tableDescription){

    var piece ='';
    for (var l = 0; l < tableDescription.length; l++) {

        if (!tableDescription[l].Show) continue;
                    
        var value =  _desiteVPList[vpNumber].vp[tableDescription[l].Property];
        

       // console.log("l: " + l + " prop:  " + tableDescription[l].Property + " value " + value + "Descr: " + tableDescription[l].Description)

        if (tableDescription[l].Description == "FirstColumnWithToolTip"){

           // var tooltipKeys = Object.keys(tableDescription[l].Tooltip);
           // var  toolTipForVP = collectDataForVPToolTipByNumber(vpNumber);
            var toolTipForVP = collectDataForTooltip(tableDescription[l].Tooltip, _desiteVPList[vpNumber]);

            piece += '<td><a class="classForTooltip" title="" data-tooltip="' + toolTipForVP + '">' + value + '</a></td>';
        }
        if (tableDescription[l].Description == "String"){

            if (value === null || value === undefined || value.length == 0){
                value = "-/-"
            }
            piece += '<td>' + value + '</td>';
        }
        if (tableDescription[l].Description == "Thumbnail"){
            
            if (_desiteVPList[vpNumber].vp.thumbnail.length == 0) {

                image_refa_vpNumber = '<a  id= "aId' + vpNumber + '" href = "icons/office_building_128x128.png"  data-lightbox = "snapshot" data-title="">';
                image_refa_vpNumber += '<img id="imgId' + vpNumber + '" src="icons/office_building_128x128.png"  alt="Image"  height="64" width="100px" > </a>';
            } 
            else 
            {

                image_refa_vpNumber = '<a  id= "aId' + vpNumber + '" href = "data:image/png;base64,' + _desiteVPList[vpNumber].vp.thumbnail + '"  data-lightbox = "snapshot" data-title="" >';
                image_refa_vpNumber += '<img id="imgId' + vpNumber + '" src = "data:image/png;base64,' + _desiteVPList[vpNumber].vp.thumbnail + '"   alt="Image"  height="64" width="100px" > </a>';
            }
            piece += '<td  width="70" height="70">' + image_refa_vpNumber + '</td>';
           
        }
        if (tableDescription[l].Description == "ButtonApplyVP"){
            
            piece += '<td align="center" width="24"><a href="javascript:applyView(' + vpNumber + ')"><img class="btnImg" src="icons/eye_64x64_green.png" width="48"  title=""></a></td>';
           
        }
        if (tableDescription[l].Description == "DateWithTime"){
            
                if (value === null || value === undefined || value.length === 0){
                displayDate = "-/-"
            }else{
                // format date
              var  date = value.replace('T', '  ');
              var  displayDate = date.slice(0, 20);
            }
            piece += '<td>' + displayDate + '</td>';
        }
    }
    return piece;
}

function buildPieceOfRowForTablePM(pmNumber, tableDescription, viewpointsMacroRowId, pmNumRevVersObject){

    var piece = '';
    var bim_doc_id = _pmList[pmNumber].bim_doc_id;
    var bim_doc_id_splitting = bim_doc_id.split("-");
    var bim_doc_number = bim_doc_id_splitting[0] + "-" + bim_doc_id_splitting[1];
  
    //console.log("bim_doc_number: " + bim_doc_number );
         
    for (var k = 0; k < tableDescription.length; k++) {

        if (!tableDescription[k].Show) continue;
                    
        var value =  _pmList[pmNumber][tableDescription[k].Property];

        // console.log("k: " + k + " prop:  " + tableDescription[k].Property + " value " + value + "Descr: " + tableDescription[k].Description)

        if (tableDescription[k].Description == "FirstColumnWithToolTip"){

            var toolTipForPM = collectDataForTooltip(tableDescription[k].Tooltip, _pmList[pmNumber]);
            piece += '<td><a class="classForTooltip" title="" data-tooltip="' + toolTipForPM + '">' + value + '</a></td>';
            
        }
        if (tableDescription[k].Description == "String"){

            var exclamationMark = '';
            if (value === null || value === undefined || value.length === 0){
                value = "-/-"
            }else if(tableDescription[k].Property == 'Revision'){
                if (!isEmptyObject(pmNumRevVersObject) && pmNumRevVersObject[bim_doc_number] != null && pmNumRevVersObject[bim_doc_number][_pmList[pmNumber]['Revision']] == null){
                    exclamationMark = '<b><font color="red"> ! </font></b>';
                }
            }else if(tableDescription[k].Property == 'Version'){
                if(!isEmptyObject(pmNumRevVersObject) && pmNumRevVersObject[bim_doc_number] != null && pmNumRevVersObject[bim_doc_number][_pmList[pmNumber]['Revision']] != null &&
                    pmNumRevVersObject[bim_doc_number][_pmList[pmNumber]['Revision']].indexOf(_pmList[pmNumber]['Version']) == -1){
                        exclamationMark = '<b><font color="red"> ! </font></b>';
                }
            }
            
            piece += '<td>' + exclamationMark + value + exclamationMark +  '</td>';
        }
        if (tableDescription[k].Description == "pmFilename"){
            
            console.log("!!! Description: pmFilename; _pmList[pmNumber].pmFilename: " + _pmList[pmNumber].pmFilename);
            value = _pmList[pmNumber].pmFilename;
            if (value === null || value === undefined || value.length === 0){
                value = "-/-"
            }
            piece += '<td>' + value + '</td>';
        }
        /* 
        if (tableDescription[k].Description == "nativeModelFilename"){
            
            value = _pmList[pmNumber].nativeModelFilename;
            if (value === null || value === undefined || value.length === 0){
                value = "-/-"
            }
            piece += '<td>' + value + '</td>';
        }
         */
        if (tableDescription[k].Description == "DateWithTime"){

            if (value === null || value === undefined || value.length === 0){
                displayDate = "-/-"
            }else{
                // format date
                date = value.replace('T', '  ');
                displayDate = date.slice(0, 20);
            }
            piece += '<td>' + displayDate + '</td>';
        }
        /* 
        if (tableDescription[k].Description == "ButtonDownloadPartialModelFile"){
                             
            piece += '<td align="center" ><a href="javascript:downloadPartialModelFile2(&apos;' + _pmList[pmNumber].pmFileHref + '&apos;,&apos;' + _pmList[pmNumber].pmFilename + '&apos;)"><img class="btnImg" src="icons/download_64x64.png" width="48"  title="Download partial model file to the current project&#39;s directory"></a></td>';
        }
        */
        /* 
        if (tableDescription[k].Description == "ButtonDownloadNativeModelFile"){

             console.log("_pmList[pmNumber].nativeFileHref: " + _pmList[pmNumber].nativeModelFileHref + "     _pmList[pmNumber].nativeFilename: " + _pmList[pmNumber].nativeModelFilename);
            piece += '<td align="center" ><a href="javascript:downloadPartialModelFile2(&apos;' + _pmList[pmNumber].nativeModelFileHref + '&apos;,&apos;' + _pmList[pmNumber].nativeModelFilename + '&apos;)"><img class="btnImg" src="icons/download_64x64.png" width="48"  title="Download native model&#39;s file to the current project&#39;s directory"></a></td>';
        }
        */
        /* 
        if (tableDescription[k].Description == "ButtonImportPartialModel"){
            
            piece += '<td align="center" ><a href="javascript:importPartialModelIntoProject2(&apos;' + _pmList[pmNumber].pmFileHref + '&apos;,&apos;' + _pmList[pmNumber].pmFilename + '&apos;)"><img class="btnImg" src="icons/inbox_into_64x64.png" width="48"  title="Import partial model into the current project"></a></td>';
        }
         */
        /* 
        if (tableDescription[k].Description == "ButtonImportNativeModel"){

            piece += '<td align="center" ><a href="javascript:importPartialModelIntoProject2(&apos;' + _pmList[pmNumber].nativeModelFileHref + '&apos;,&apos;' + _pmList[pmNumber].nativeModelFilename + '&apos;)"><img class="btnImg" src="icons/inbox_into_64x64.png" width="48"  title="Import native model into the current project"></a></td>';
        }
         */
        if (tableDescription[k].Description == "SelectStatus") {

            //TIMS EDITING
            piece += '<td width="15">' + '<select name="PM_' + pmNumber + '" id="PM_' + pmNumber + '">';
            for (var l = 0; l < partialModelReviewValuesFormatted.length; l++) {
                piece += '<option value=' + partialModelReviewValuesFormatted[l];
                if (partialModelReviewValuesFormatted[l] == _pmList[pmNumber].status) {
                    piece += ' selected>';
                }
                else {
                    piece += '>';
                }
                piece += partialModelReviewValuesFormatted[l] + '</option>';
            }
            piece += '</select></td>';
            //TIMS EDITING
        }
        if (tableDescription[k].Description == "ButtonWriteComment"){

            //TIMS EDITING
            piece += '<td align="center" ><a href="javascript:PMComment(' + pmNumber + ');"><img class="btnImg" src="icons/ballpen_64x64.png" width="48"  title="Write comment"></a></td>';
            //piece += '<td><input type ="button" value=" Write Comment" onclick="PMComment(' + pmNumber + ');"></td>';
            //TIMS EDITING
        }
        if (tableDescription[k].Description == "ButtonSendStatus"){

            //TIMS EDITING
            piece += '<td align="center" ><a href="javascript:updateDocumentPM(' + pmNumber + ');"><img class="btnImg" src="icons/mail_forward_64x64.png" width="48"  title="Send status and comment"></a></td>';
            //piece += '<td><input type ="button" value="Send Status" onclick="updateDocumentPM(' + pmNumber + ');"></td>';
            //TIMS EDITING
        }
        if (tableDescription[k].Description == "ButtonDownloadAndImportFiles"){

            piece += '<td align="center" ><a href="javascript:downloadAndImportFiles(' + pmNumber + ');"><img class="btnImg" src="icons/inbox_into_64x64.png" width="48"  title="Download and import model file into the current project"></a></td>';

            // piece += '<td><input type ="button" value="Download & Import" onclick="downloadAndImportFiles(' + pmNumber + ');"></td>';
            
        }
        if (tableDescription[k].Description == "ButtonShowHideViewpointsForPM"){

            if (_viewpoints.loaded == true && _pmList[pmNumber].vpDocs !== null && _pmList[pmNumber].vpDocs !== undefined) {
                piece += '<td align="center" width="35" >' + '<button  class="iconbtn" type="button" onclick="showHideViewpointsMacroRowForPM(&apos;' + _pmList[pmNumber].vpDocs.length + '&apos;,&apos;' + viewpointsMacroRowId + '&apos;); return false;" title="Show/Hide related viewpoints">';
                piece += '<span class="fa-stack" style="font-size:18px;  color:#99c33a; "> <span class="fa fa-circle fa-stack-2x"></span>';
                piece += '<strong class="fa-stack-1x" style="color:white;">' + _pmList[pmNumber].vpDocs.length + ' </strong> </span> </button> </td>';
            } else {
                piece += '<td align="center" width="35" >' + '<button  class="iconbtn" type="button" onclick="showHideViewpointsMacroRowForPM(&apos;' + _pmList[pmNumber].vpDocs.length + '&apos;,&apos;' + viewpointsMacroRowId + '&apos;); return false;" title="Show/Hide related viewpoints">';
                piece += '<span class="fa-stack" style="font-size:18px;  color:#99c33a; "> <span class="fa fa-circle fa-stack-2x"></span>';
                piece += '<strong class="fa-stack-1x" style="color:white;"> ? </strong> </span> </button> </td>';
            }
        }
        if (tableDescription[k].Description == "ButtonPostViewpointFromTablePM"){

            piece += '<td align="center" ><a href="javascript:sendVPtoTPWithPartialModelId(' + pmNumber + ')"><img class="btnImg" src="icons/compact_camera_64x64.png" width="48"  title="Post 3D View as viewpoint to tp and relate to this Model"></a></td>';
        }
    }
    return piece;
}

//--------------------------------------------------------------------------------------------------------

function buildPieceOfRowForSubtablePM(partialModel, tableDescription, viewpointsMacroRowId, pmNumRevVersObject){

    var piece = '';
    
    var bim_doc_id = partialModel.bim_doc_id;
    var bim_doc_id_splitting = bim_doc_id.split("-");
    var bim_doc_number = bim_doc_id_splitting[0] + "-" + bim_doc_id_splitting[1];
   
    //console.log("bim_doc_number: " + bim_doc_number);
              
    for (var k = 0; k < tableDescription.length; k++) {

        if (!tableDescription[k].Show) continue;
                    
        var value =  partialModel[tableDescription[k].Property];

       // console.log("k: " + k + " prop:  " + tableDescription[k].Property + " value " + value + "Descr: " + tableDescription[k].Description)

        if (tableDescription[k].Description == "FirstColumnWithToolTip"){

            var toolTipForPM = collectDataForTooltip(tableDescription[k].Tooltip, partialModel);
            piece += '<td><a class="classForTooltip" title="" data-tooltip="' + toolTipForPM + '">' + value + '</a></td>';
        }
        if (tableDescription[k].Description == "String"){
           
            var exclamationMark = '';
            if (value === null || value === undefined || value.length === 0){
                value = "-/-"
            }else if(tableDescription[k].Property == 'Revision'){
                if (!isEmptyObject(pmNumRevVersObject) && pmNumRevVersObject[bim_doc_number] != null && pmNumRevVersObject[bim_doc_number][partialModel['Revision']] == null){
                    exclamationMark = '<b><font color="red"> ! </font></b>';
                }
            }else if(tableDescription[k].Property == 'Version'){
                if(!isEmptyObject(pmNumRevVersObject) && pmNumRevVersObject[bim_doc_number] != null && pmNumRevVersObject[bim_doc_number][partialModel['Revision']] != null &&
                    pmNumRevVersObject[bim_doc_number][partialModel['Revision']].indexOf(partialModel['Version']) == -1){
                        exclamationMark = '<b><font color="red"> ! </font></b>';
                }
            }
            piece += '<td>' + exclamationMark + value + exclamationMark +  '</td>';
        }

        if (tableDescription[k].Description == "pmFilename"){
            
            // console.log("!!! Description: pmFilename; partialModel.pmFilename: " + partialModel.pmFilename);
            value = partialModel.pmFilename;
            if (value === null || value === undefined || value.length === 0){
                value = "-/-"
            }
            piece += '<td>' + value + '</td>';
        }
        /* 
        if (tableDescription[k].Description == "nativeModelFilename"){
            
            value = partialModel.nativeModelFilename;
            if (value === null || value === undefined || value.length === 0){
                value = "-/-"
            }
            piece += '<td>' + value + '</td>';
        }
         */
        if (tableDescription[k].Description == "DateWithTime"){

            if (value === null || value === undefined || value.length === 0){
                displayDate = "-/-"
            }else{
                // format date
                date = value.replace('T', '  ');
                displayDate = date.slice(0, 20);
            }
            piece += '<td>' + displayDate + '</td>';
        }
       /* 
        if (tableDescription[k].Description == "ButtonDownloadPartialModelFile"){
                             
            piece += '<td align="center" ><a href="javascript:downloadPartialModelFile2(&apos;' + partialModel.pmFileHref + '&apos;,&apos;' + partialModel.pmFilename + '&apos;)"><img class="btnImg" src="icons/download_64x64.png" width="48"  title="Download partial model file to the current project&#39;s directory"></a></td>';
        }
        */
        /* 
        if (tableDescription[k].Description == "ButtonDownloadNativeModelFile"){

             // console.log("partialModel.nativeFileHref: " + partialModel.nativeModelFileHref + "     partialModel.nativeFilename: " + partialModel.nativeModelFilename);
            piece += '<td align="center" ><a href="javascript:downloadPartialModelFile2(&apos;' + partialModel.nativeModelFileHref + '&apos;,&apos;' + partialModel.nativeModelFilename + '&apos;)"><img class="btnImg" src="icons/download_64x64.png" width="48"  title="Download native model&#39;s file to the current project&#39;s directory"></a></td>';
        }
        */ 
        /* 
        if (tableDescription[k].Description == "ButtonImportPartialModel"){
            
            piece += '<td align="center" ><a href="javascript:importPartialModelIntoProject2(&apos;' + partialModel.pmFileHref + '&apos;,&apos;' + partialModel.pmFilename + '&apos;)"><img class="btnImg" src="icons/inbox_into_64x64.png" width="48"  title="Import partial model into the current project"></a></td>';
        }
        */
        /* 
        if (tableDescription[k].Description == "ButtonImportNativeModel"){

            piece += '<td align="center" ><a href="javascript:importPartialModelIntoProject2(&apos;' + partialModel.nativeModelFileHref + '&apos;,&apos;' + partialModel.nativeModelFilename + '&apos;)"><img class="btnImg" src="icons/inbox_into_64x64.png" width="48"  title="Import native model into the current project"></a></td>';
        }
         */
        if (tableDescription[k].Description == "ButtonDownloadAndImportFiles"){
            
            piece += '<td align="center" ><a href="javascript:downloadAndImportFiles2(&apos;' + partialModel.bim_doc_id + '&apos;);"><img class="btnImg" src="icons/inbox_into_64x64.png" width="48"  title="Download and import model file into the current project"></a></td>';
           // piece += '<td><input  type ="button" class="btnx"  value="Download & Import" onclick="downloadAndImportFiles2(&apos;' + partialModel.bim_doc_id + '&apos;);"></td>';
            
        }
        if (tableDescription[k].Description == "ButtonShowHideViewpointsForPM"){

            if (_viewpoints.loaded == true && partialModel.vpDocs !== null && partialModel.vpDocs !== undefined) {
                piece += '<td align="center" width="35" >' + '<button  class="iconbtn" type="button" onclick="showHideViewpointsMacroRowForPM(&apos;' + partialModel.vpDocs.length + '&apos;,&apos;' + viewpointsMacroRowId + '&apos;); return false;" title="Show/Hide related viewpoints">';
                piece += '<span class="fa-stack" style="font-size:18px;  color:#99c33a; "> <span class="fa fa-circle fa-stack-2x"></span>';
                piece += '<strong class="fa-stack-1x" style="color:white;">' + partialModel.vpDocs.length + ' </strong> </span> </button> </td>';
            } else {
                piece += '<td align="center" width="35" >' + '<button  class="iconbtn" type="button" onclick="showHideViewpointsMacroRowForPM(&apos;' + partialModel.vpDocs.length + '&apos;,&apos;' + viewpointsMacroRowId + '&apos;); return false;" title="Show/Hide related viewpoints">';
                piece += '<span class="fa-stack" style="font-size:18px;  color:#99c33a; "> <span class="fa fa-circle fa-stack-2x"></span>';
                piece += '<strong class="fa-stack-1x" style="color:white;"> ? </strong> </span> </button> </td>';
            }
        }
        if (tableDescription[k].Description == "ButtonPostViewpointFromSubtablePM"){

            piece += '<td align="center" ><a href="javascript:sendVPtoTPWithPartialModelId2(&apos;' + partialModel.bim_doc_id + '&apos;)"><img class="btnImg" src="icons/compact_camera_64x64.png" width="48"  title="Post 3D View as viewpoint to tp and relate to this Model"></a></td>';
        }
    }
    return piece;
}

function generateSearchFieldsForMainTable(tableId){
   
    retString = '';
    // console.log(JSON.stringify(_config.ProjectDescription));
    // console.log("\n  split('table')[1]:  " + tableId.split('table')[1])
    
    var tableDescription = _config.ProjectDescription[tableId.split('table')[1]].MainTable;
    //_tablePartialModelsDescription =  __projects__[i].ProjectDescription.PartialModels.MainTable;
    // _tableCoordinationModelsDescription =  __projects__[i].ProjectDescription.CoordinationModels.MainTable;
    //_tableViewpointsDescription =  __projects__[i].ProjectDescription.Viewpoints.MainTable;
    retString += '<tr>';
    retString += '<td align="center" ><a href="javascript:searchInMainTable1()"><img class="btnImg" src="icons/magnifying_glass_24x24.png"   title=""></a></td>';
    

    for (var i = 0; i < tableDescription.length; i++) {

        if (!tableDescription[i].Show) continue;
        
        var style_width = '';
        if (tableDescription[i].Width != ''){
            style_width = 'style="min-width:' + tableDescription[i].Width + 'px !important;"';
        }
        if (tableDescription[i].Description.indexOf("Button") == -1 && 
             tableDescription[i].Description.indexOf("Thumbnail") == -1){

            if( Object.keys(_displayedTableSearchFieldsValues).length != 0 ){
               var value = _displayedTableSearchFieldsValues[tableDescription[i].Property]; 
            }else value = '';
               retString += '<td><input type="text" class="cp" onkeypress="handleKeyPress(event)" class="text  ui-widget-content ui-corner-all"  style="font: 16px Verdana, sans-serif; width:100%;" value="' + value +'"';
               retString += 'id="' + tableDescription[i].Property + '"';
               retString += '></td>';
        }else{
            retString += '<td> </td>';
        }
    }
    retString += '</tr>';

    return retString;
}

function handleKeyPress(e){
    var key=e.keyCode || e.which;
    // console.log("key: " + key);
    if (key==13){
      var activeElementId = document.activeElement.id;
      var inputElement = document.getElementById(activeElementId);
      var inputVal = inputElement.value;
      searchInMainTable1();
      setTimeout(function(){
        inputElement = document.getElementById(activeElementId);
        inputElement.value = "";
        inputElement.value = inputVal;
        inputElement.focus();
        var activeElementIdNow = document.activeElement.id;
        // console.log("activeElementIdNow : " + activeElementIdNow);
      }, 100);
    }
}

function searchInMainTable1(){
    
    var type = "";
    if (_displayedTable.type == "VPC"){
        type = "Viewpoints";
    }else if (_displayedTable.type == "PMC"){
        type = "PartialModels";
    }else type = "CoordinationModels";

    var tableId = "table" + type;
    // console.log("type:  " + type);
    var objectList = [];
    //--------------------------------------------------------
    
    if (type == "Viewpoints") {
         for (var i = 0; i < _desiteVPList.length; i++){
             objectList.push(_desiteVPList[i].vp);
         } 
     }else if (type == "PartialModels"){
            objectList = JSON.parse(JSON.stringify(_pmList));
     }else if (type == "CoordinationModels"){
            objectList = JSON.parse(JSON.stringify(_cmList));
     }
        
     //----------------------------------------------------------
     /* 
        for (var i = 0; i < _rowNumbersToShow.length; i++){
            row_i = _rowNumbersToShow[i];
            if (type == "Viewpoints") {
               objectList.push(_desiteVPList[row_i].vp);
            }
            if (type == "PartialModels"){
                objectList.push(_pmList[row_i]);
            }
            if (type == "CoordinationModels"){
                objectList.push(_cmList[row_i]);
            }
        } 
     */
     //-----------------------------------------------------------
     var rowNumbersToShowNew = [];
     for (var i = 0; i < objectList.length; i++){
         
         var check = true;
         for (var j = 0; j < _config.ProjectDescription[type].MainTable.length; j++){

             if (!_config.ProjectDescription[type].MainTable[j].Show) continue;
 
             if(_config.ProjectDescription[type].MainTable[j].Description.indexOf("Button") == -1 &&
                _config.ProjectDescription[type].MainTable[j].Description.indexOf("Thumbnail") == -1){
                 
                 var property = _config.ProjectDescription[type].MainTable[j].Property;
                  // console.log("property: " + property);
                 var value = objectList[i][property];
                  // console.log("value > " + value);

                 if (_config.ProjectDescription[type].MainTable[j].Description == "DateWithTime"){
                        value = value.replace('T', '  ');
                 }
                 if (value != '' && value != null && value.indexOf("<xhtml>") != -1) {
                    // console.log("value:  " + value);
                    var htmlObject = $(value);
                    value = htmlObject.text();
                    // console.log("Now value:  " + value);
                 }
                 // console.log("value: "  + value);
                 var textToSearch = document.getElementById(property).value;
                 // console.log("Text to search: " + textToSearch);
                 
                 if (value.toLowerCase().indexOf(textToSearch.toLowerCase()) == -1){
                     check = false;
                     break;
                 }
             }
         }
         if (check) {
              rowNumbersToShowNew.push(i);
             //rowNumbersToShowNew.push(_rowNumbersToShow[i]);
         }
     } 
     _rowNumbersToShow = rowNumbersToShowNew.slice();
 
     for (var j = 0; j < _config.ProjectDescription[type].MainTable.length; j++){
          
          if (!_config.ProjectDescription[type].MainTable[j].Show) continue;

          prop = _config.ProjectDescription[type].MainTable[j].Property;
          // console.log("prop: " + prop);
         if(prop != ''){
            _displayedTableSearchFieldsValues[prop] = document.getElementById(prop).value.replace(/"/g, "&quot;");
         }
     }
 
     setNumberOfPages();
     _currentPageNumber = 1;
     buildBimdocnumRevisionVersionObjectForParialModelsInDesite().then(
        function(pmNumRevVersObject) {buildPage(tableId, _currentPageNumber, pmNumRevVersObject);} 
    );
     
 }
 

function generateSearchFieldsForSubtable(macroRowId){

    var retString = '';
    var tableTyp ='';
    var tableDescription ='';
    if (macroRowId.indexOf('Vps') != -1){
        if (macroRowId.indexOf('tabpm') != -1){
           tableTyp = 'PartialModels';
        }else if (macroRowId.indexOf('tabcm') != -1){
            tableTyp = 'CoordinationModels';
        }
        tableDescription = _config.ProjectDescription[tableTyp].SubtableViewpoints;
    }else{
        tableDescription = _config.ProjectDescription.CoordinationModels.SubtablePartialModels;
    }

    retString += '<tr>';
    //retString = '<td>  </td>';
    retString += '<td align="center" ><a href="javascript:searchInSubtable(&apos;' + macroRowId + '&apos;)"><img class="btnImg" src="icons/magnifying_glass_24x24.png"   title=""></a></td>';

    for (var i = 0; i < tableDescription.length; i++) {
        
        if (!tableDescription[i].Show) continue;

        var style_width = '';
        if (tableDescription[i].Width != ''){
            style_width = 'style="min-width:' + tableDescription[i].Width + 'px !important;"';
        }
        if (tableDescription[i].Description.indexOf("Button") == -1 && 
             tableDescription[i].Description.indexOf("Thumbnail") == -1){
             retString += '<td><input type="text" class="cp" onkeypress="handleKeyPressSubtable(event' + ',&apos;' + macroRowId + '&apos;)" class="text  ui-widget-content ui-corner-all"  style="font: 16px Verdana, sans-serif; width:100%;" value=""';
             retString += 'id="'+ macroRowId + '##' + tableDescription[i].Property  + '"';
             retString += '></td>';
        }else{
            retString += '<td> </td>';
        }
    }
    retString += '</tr>';
    return retString;
}

function handleKeyPressSubtable(e, macroRowId){
    var key=e.keyCode || e.which;
    if (key==13){
        searchInSubtable(macroRowId);
    }
}
function searchInSubtable(macroRowId){
    
    // console.log("macroRowId: " + macroRowId);
    var  modelNumer = macroRowId.split("_")[1];
    var partial_submodel_number = macroRowId.split("_")[2];
    var tableDescription ='';
    var tableTyp ='';
    
    if (macroRowId.indexOf('Vps') != -1){
        if (macroRowId.indexOf('tabpm') != -1){
           tableTyp = 'PartialModels';
        }else if (macroRowId.indexOf('tabcm') != -1){
            tableTyp = 'CoordinationModels';
        }
        tableDescription = _config.ProjectDescription[tableTyp].SubtableViewpoints;
    }else{
        tableDescription = _config.ProjectDescription.CoordinationModels.SubtablePartialModels;
    }
    
    var displayedModels = [];
    if (_displayedTable.type == "PMC"){
        displayedModels = JSON.parse(JSON.stringify(_pmList));
    }else if (_displayedTable.type == "CMC"){
        displayedModels = JSON.parse(JSON.stringify(_cmList));
    }

    //var tableId = "table" + type;
    var objectList = [];
      
    if (macroRowId.indexOf('Vps') != -1){
        if (partial_submodel_number === null || partial_submodel_number === undefined ){
           for (var l = 0; l < displayedModels[modelNumer].vpDocs.length; l++) {
              var vpNumber = _viewpoints.idsAndNumbers[displayedModels[modelNumer].vpDocs[l].bim_doc_id];
              var rowId = "vpRow_" + modelNumer + "_" + l;
              if(checkObject(_desiteVPList[vpNumber].vp, tableDescription, macroRowId)){
                   document.getElementById(rowId).style.display = 'table-row';
              }else{
                   document.getElementById(rowId).style.display = 'none';
              }
               objectList.push(_desiteVPList[vpNumber].vp);
            }
        }else{
            var pm = JSON.parse(JSON.stringify(searchPartialModelWithId(_cmList[modelNumer].pmDocs[partial_submodel_number].bim_doc_id)));
            for (var z = 0; z < pm.vpDocs.length; z++) {
                var vpNumber1 = _viewpoints.idsAndNumbers[pm.vpDocs[z].bim_doc_id];
                var rowId = "vpRow_" + modelNumer + "_" + partial_submodel_number + "_" + z;
                if(checkObject(_desiteVPList[vpNumber1].vp, tableDescription, macroRowId)){
                    document.getElementById(rowId).style.display = 'table-row';
                }else{
                    document.getElementById(rowId).style.display = 'none';
                }
                objectList.push(_desiteVPList[vpNumber1].vp)
            }
        }   
    }else{
           
        for (var l = 0; l < _cmList[modelNumer].pmDocs.length; l++) {
           
            var pm = JSON.parse(JSON.stringify(searchPartialModelWithId(_cmList[modelNumer].pmDocs[l].bim_doc_id)));
            var rowId = "pmRow_" + modelNumer + "_" + l;

            var viewpointsMacroRowIdForSubsubtable = 'tabCMsubtabpmSubsubtabVpsMacroRow_' + modelNumer + '_' + l;
            // console.log("el Id: " + viewpointsMacroRowIdForSubsubtable);
            var el = document.getElementById(viewpointsMacroRowIdForSubsubtable); 
            if (el != null) { 
                // console.log("el != null,  Id: " + viewpointsMacroRowIdForSubsubtable);
                document.getElementById(viewpointsMacroRowIdForSubsubtable).style.display = 'none';
                 var macroRowTableRows = document.getElementById(viewpointsMacroRowIdForSubsubtable).cells[0].getElementsByTagName("table")[0].rows;
                var searchFields = macroRowTableRows[4].getElementsByTagName("input");
                // console.log("search fields length: " + searchFields.length);
                for (q = 0; q < searchFields.length; q++){
                    console.log("search field: " + q + " :  " + searchFields[q].value);
                    searchFields[q].value ='';
                } 
                for (p = 0; p < macroRowTableRows.length; p++){
                    macroRowTableRows[p].style.display ='table-row';
                }
            } 

            if(checkObject(pm, tableDescription, macroRowId)){
                document.getElementById(rowId).style.display = 'table-row';
            }else{
                document.getElementById(rowId).style.display = 'none';
            }
            objectList.push(pm);
        }
    }
}

function checkObject(object, tableDescription, macroRowId){
    
    var type = ';'
    if (macroRowId.indexOf('Vps') != -1){
          type = "Viewpoints";
    }else{
          type = "PartialModels";
    }
    var check = true;
        for (var j = 0; j < tableDescription.length; j++){

            if (!tableDescription[j].Show) continue;

            if(tableDescription[j].Description.indexOf("Button") == -1 &&
               tableDescription[j].Description.indexOf("Thumbnail") == -1){
                
                var property = tableDescription[j].Property;
                //console.log("property: " + property);
                var value = object[property];
                if (tableDescription[j].Description == "DateWithTime"){
                       value = value.replace('T', '  ');
                }

                if (value != '' && value != null && value.indexOf("<xhtml>") != -1){
                 // console.log("value:  " + value);
                 var htmlObject = $(value);
                 value = htmlObject.text();
                 // console.log("Now value:  " + value);
                }
                //console.log(">>PropertyValue: " + value);
                var textToSearch = document.getElementById(macroRowId + '##' + property).value;
                //console.log(">>textToSearch: " + textToSearch);
                if (value.toLowerCase().indexOf(textToSearch.toLowerCase()) == -1){
                    check = false;
                    break;
                }
            }
        }
    return check;
}

//--------------------------------------------------------------------------------------------------------
                
function buildPage(tableId, pageNumber, pmNumRevVersObject) {

    //console.log('BEGIN buildPage(tableId, pageNumber)   pageNumber: ' + pageNumber + ' tableId: ' + tableId);

    //console.log('_numberOfPages: ' + _numberOfPages);
    //console.log('_numberOfRowsToShow: ' + _numberOfRowsToShow);

    var firstLine = _pageLength * (pageNumber - 1);
    var lastLine;
    if (pageNumber != _numberOfPages) {
        lastLine = _pageLength * pageNumber - 1;
    } else {
        lastLine = _numberOfRowsToShow - 1;
    }
    var tableTitle = '';
    //console.log('firstLine: ' + firstLine);
    //console.log('lastLine: ' + lastLine);

    //------------------------- VIEWPOINTS-------------------------------

    if (tableId == 'tableViewpoints') {

        _tblVP = document.getElementById('tableViewpoints');

        if (_numberOfPages != 0) {
            numberOfPagesDisplay = _numberOfPages;
        } else numberOfPagesDisplay = 1;

        _tabVP = '<br><table style="width:100%">';
        _tabVP += '<tr>';
        _tabVP += '<td width="450px" align="left">';
        _tabVP += '<table>';
        _tabVP += '<tr>';
        _tabVP += '<td align="right" ><b>Current 3D Viewpoints &nbsp</b></td>';
        _tabVP += '<td id ="Found" align="right" ><b>[found:&nbsp </b></td>';
        _tabVP += '<td align="left" id="NumberOfVPs" width="20"><b>' + _rowNumbersToShow.length + ']</b></td>';
        _tabVP += '</tr>';
        _tabVP += '</table>';
        _tabVP += '</td>';
        _tabVP += '<td>';
        _tabVP += '</td>';
        _tabVP += '<td width="100px" align="right">';
        _tabVP += '<table>';
        _tabVP += '<tr>';
        _tabVP += '<td id="leftarrow" align="right" width="16"><a href="javascript:toPreviousPage(&apos;' + tableId + '&apos;)"><img class="btnImg" src="icons/media_step_back_24x24.png" title="leftarrow"></a></td>';
        _tabVP += '<td align="right" >Page: </td>';
        _tabVP += '<td align="left" id="currentPageNumberVP" width="20"><b>' + pageNumber + '/' + numberOfPagesDisplay + '</b></td>';
        _tabVP += '<td id="rightarrow" align="right" width="16"><a href="javascript:toNextPage(&apos;' + tableId + '&apos;)"><img class="btnImg" src="icons/media_step_forward_24x24.png" title="rightarrow"></a></td>';
        _tabVP += '</tr>';
        _tabVP += '</table>';
        _tabVP += '</td>';
        _tabVP += '</tr>';
        _tabVP += '</table><br>';
        _tabVP += '<form name="formTableVP">';
        _tabVP += '<table style="width:100%" cellspacing="2" cellpadding="4" class="maintable">';
        _tabVP += '<tr>';
        //_tabVP += '<td width="5"><b> </b></td>';
        _tabVP += '<td> <select class="active"  id="selectColumnsTableViewpoints"  multiple="multiple" title="Show/Hide columns" > </select> </td>';

        for (var i = 0; i <_tableViewpointsDescription.length; i++) {

            if (!_tableViewpointsDescription[i].Show) continue;
            var style_width = '';
            if (_tableViewpointsDescription[i].Width != ''){
                style_width = 'style="min-width:' +_tableViewpointsDescription[i].Width + 'px !important;"';
            }
            
            _tabVP += '<td ' + style_width + '><b>' + _tableViewpointsDescription[i].ColumnTitle +'</b></td>';
        }
        
        _tabVP += '</tr>';

        _tabVP += generateSearchFieldsForMainTable(tableId);

        var classname;
        var k = 0;
        var m = firstLine;

        if (_numberOfPages != 0) {
            for (var i = firstLine; i <= lastLine; i++) {
                var row_i = _rowNumbersToShow[i];

                if (k % 2 == 0) {
                    classname = "odd";
                } else {
                    classname = "even";
                }
               
                var j = row_i + 1;
                m++;
                if (_rowNumbersToShow.length == _desiteVPList.length) {
                    numberDisplay = j;
                } else {
                    numberDisplay = m + '&nbsp;(' + j + ')';
                }
                                
                // Check:  image is actually valid base64?
                
                ////console.log("row_i:  " + row_i + " Regex.test: "+  base64Regex.test(_desiteVPList[row_i].vp.thumbnail));
                // //console.log("row_i:  " + row_i + " thumbnail: \n" +  _desiteVPList[row_i].vp.thumbnail + "\n");

                                
                _tabVP += '<tr class="' + classname + '">';
                _tabVP += '<td width="5">' + numberDisplay + '</td>';
                _tabVP += buildPieceOfRowForTableVP(row_i, _tableViewpointsDescription);
                _tabVP += '</tr>'; //!!!
                k++;
            }
        }
        _tabVP += '</table> </form>';
        _tblVP.innerHTML = _tabVP;
    }

    //----------------------------------- PARTIAL MODELS---------------------------------------

    if (tableId == "tablePartialModels") {

        console.log("From table PM  _pmList.length: " + _pmList.length);

        _tblPM = document.getElementById('tablePartialModels');

        if (_numberOfPages != 0) {
            numberOfPagesDisplay = _numberOfPages;
        } else numberOfPagesDisplay = 1;
        
        if ( _displayedTable.filter == "current"){
            tableTitle = 'Current ' + _template_Partial +  ' Models';
        }else{
            tableTitle = 'All '+ _template_Partial  +' Models';
        }
        _tabPM =  '<br><table style="width:100%">';
        _tabPM += '<tr>';
        _tabPM += '<td width="450px" align="left">';
        _tabPM += '<table>';
        _tabPM += '<tr>';
        _tabPM += '<td align="right" ><b>' + tableTitle +  '&nbsp <b></td>';
        _tabPM += '<td id ="Found" align="right" ><b>[found:&nbsp <b></td>';
        _tabPM += '<td align="left" id="NumberOfPMs" width="20"><b>' + _rowNumbersToShow.length + ']</b></td>';
        _tabPM += '</tr>';
        _tabPM += '</table>';
        _tabPM += '</td>';
        _tabPM += '<td> </td>';
        _tabPM += '<td width="100px" align="right">';
        _tabPM += '<table>';
        _tabPM += '<tr>';
        _tabPM += '<td id="leftarrow" align="right" width="16"><a href="javascript:toPreviousPage(&apos;' + tableId + '&apos;)"><img class="btnImg" src="icons/media_step_back_24x24.png" title="leftarrow"></a></td>';
        _tabPM += '<td align="right" >Page: </td>';
        _tabPM += '<td align="left" id="currentPageNumberPM" width="20"><b>' + pageNumber + '/' + numberOfPagesDisplay + '</b></td>';
        _tabPM += '<td id="rightarrow" align="right" width="16"><a href="javascript:toNextPage(&apos;' + tableId + '&apos;)"><img class="btnImg" src="icons/media_step_forward_24x24.png" title="rightarrow"></a></td>';
        _tabPM += '</tr>';
        _tabPM += '</table>';
        _tabPM += '</td>';
        _tabPM += '</tr>';
        _tabPM += '</table><br>';
       
        _tabPM += '<form name="formTablePM">';
        _tabPM += '<table style="width:100%; border: 1px solid white; border-collapse:separate; border-spacing: 0px 2px;" >';
        _tabPM += '<tr>';
        //_tabPM += '<td width="5"><b> </b></td>';
        _tabPM += '<td> <select class="active"  id="selectColumnsTablePartialModels"  multiple="multiple" title="Show/Hide columns" > </select> </td>';

        for (var i = 0; i <_tablePartialModelsDescription.length; i++) {
            // console.log(i + "    " + _tablePartialModelsDescription[i].Show);
            if (!_tablePartialModelsDescription[i].Show) continue;

            var style_width = '';
            if (_tablePartialModelsDescription[i].Width != ''){
                style_width = 'style="min-width:' +_tablePartialModelsDescription[i].Width + 'px !important;"';
            }
            _tabPM += '<td ' + style_width + '><b>' + _tablePartialModelsDescription[i].ColumnTitle +'</b></td>';
        }
        
        _tabPM += '</tr>';
        //console.log("After _tabPM = ...");    

        _tabPM += generateSearchFieldsForMainTable(tableId);
              
        var classname; // "odd" or "even"
        //var k = 0;
        var m = firstLine;

        if (_numberOfPages != 0) {
            for (var i = firstLine; i <= lastLine; i++) {
                row_i = _rowNumbersToShow[i];

                j = row_i + 1;
                m++; 

                if (_rowNumbersToShow.length == _pmList.length) {
                    numberDisplay = j;
                } else {
                    numberDisplay = m + '&nbsp;(' + j + ')';
                }
                //console.log("numberDisplay: " + numberDisplay + " row_i:  " + row_i);
                                              
                _tabPM += '<tr class="odd">';
                _tabPM += '<td width="5">' + numberDisplay + '</td>';
                var viewpointsMacroRowId = 'tabpmVpsMacroRow_' + row_i;
                _tabPM += buildPieceOfRowForTablePM(row_i, _tablePartialModelsDescription, viewpointsMacroRowId, pmNumRevVersObject);        
                _tabPM += '</tr>';
                //k++;
                
                // Build subtable for viewpoints  
                //var w = _tablePartialModelsDescription.length + 1;
                var w = _tablePartialModels_SubtableViewpointsDescription.length + 1;
                if (_viewpoints.loaded == true && _pmList[row_i].vpDocs !== null && _pmList[row_i].vpDocs !== undefined && _pmList[row_i].vpDocs.length != 0) {
                   
                    _tabPM += '<tr id="' + viewpointsMacroRowId + '"  style="display:none;">';
                    _tabPM += '<td colspan="' + w +'">';
                    _tabPM += '<table style=" width: 100%; border: 1px solid white; border-collapse:separate; border-spacing: 0px 2px;">';

                    _tabPM += '<tr><td width="5">  </td></tr>';
                    _tabPM += '<tr id="tabpmVpsEmptyRow1_' + row_i + '"  style="display:table-row;">';

                    for (var q = 0; q < _tablePartialModelsDescription.length; q++) {
                        if (_tablePartialModelsDescription[q].Description == "FirstColumnWithToolTip"){

                            var propValue =  _pmList[row_i][_tablePartialModelsDescription[q].Property];
                            break;      
                        }
                    }
                    _tabPM += '<td  align="left" colspan="50"><b>Viewpoints related to Model &nbsp&apos;' + propValue  +'&apos; :</b></td>';
                    _tabPM += '</tr>';
                    _tabPM += '<tr><td width="5">  </td></tr>';
                    _tabPM += '<tr id="tabpmVpsTitleRow_' + row_i + '"  style="display:table-row;">';
                    _tabPM += '<td width="5"><b> </b></td>';

                    for (var t = 0; t <_tablePartialModels_SubtableViewpointsDescription.length; t++) {

                        if (!_tablePartialModels_SubtableViewpointsDescription[t].Show) continue;
                        var style_width = '';
                        /*
                        if (_tablePartialModels_SubtableViewpointsDescription[t].Width != ''){
                            style_width = 'style="min-width:' +_tablePartialModels_SubtableViewpointsDescription[t].Width + 'px !important;"';
                        }
                        */
                        _tabPM += '<td ' + style_width + '><b>' + _tablePartialModels_SubtableViewpointsDescription[t].ColumnTitle +'</b></td>';
                    }
                    _tabPM += '</tr>';
                    // Search row
                    
                    _tabPM += generateSearchFieldsForSubtable(viewpointsMacroRowId);
                    

                    for (var l = 0; l < _pmList[row_i].vpDocs.length; l++) {

                        //console.log('l: ' + l + ' Viewpoint-Id: ' + _pmList[row_i].vpDocs[l].bim_doc_id);
                        //console.log('_pmList[row_i].vpDocs[l].name: ' + _pmList[row_i].vpDocs[l].name);
                    
                        var vp_number = _viewpoints.idsAndNumbers[_pmList[row_i].vpDocs[l].bim_doc_id];
                        //console.log('----> vp_number: ' + vp_number);

                        _tabPM += '<tr id="vpRow_' + row_i + '_' + l + '" class="ededed" style="display:table-row;">';
                        _tabPM += '<td width="5"> &nbsp </td>';
                        _tabPM += buildPieceOfRowForTableVP(vp_number, _tablePartialModels_SubtableViewpointsDescription);
                        _tabPM += '</tr>';
                    }
                    _tabPM += '<tr id="tabpmVpsEmptyRow2_' + row_i + '"  style="display:table-row;"><td width="5"><b>&nbsp</b></td></tr>';
                    _tabPM += '</table>';
                    _tabPM += '</td>';
                    _tabPM += '</tr>';
                }
            }
        }
        _tabPM += '</table></form>';
        _tblPM.innerHTML = _tabPM;
    }

    //----------------------------------- COORDINATION MODELS---------------------------------------

    if (tableId == "tableCoordinationModels") {

        _tblCM = document.getElementById('tableCoordinationModels');

        if (_numberOfPages != 0) {
            numberOfPagesDisplay = _numberOfPages;
        } else numberOfPagesDisplay = 1;

        if ( _displayedTable.filter == "current"){
            tableTitle = 'Current Coordination Models';
        }else{
            tableTitle = 'All Coordination Models';
        }

        _tabCM =  '<br><table style="width:100%">';
        _tabCM += '<tr>';
        _tabCM += '<td width="550px" align="left">';
        _tabCM += '<table>';
        _tabCM += '<tr>';
        _tabCM += '<td align="right" ><b>' + tableTitle +  '&nbsp <b></td>';
        _tabCM += '<td id ="Found" align="right" ><b>[found:&nbsp <b></td>';
        _tabCM += '<td align="left" id="NumberOfCMs" width="20"><b>' + _rowNumbersToShow.length + ']</b></td>';
        _tabCM += '</tr>';
        _tabCM += '</table>';
        _tabCM += '</td>';
        _tabCM += '<td> </td>';
        _tabCM += '<td width="100px" align="right">';
        _tabCM += '<table>';
        _tabCM += '<tr>';
        _tabCM += '<td id="leftarrow" align="right" width="16"><a href="javascript:toPreviousPage(&apos;' + tableId + '&apos;)"><img class="btnImg" src="icons/media_step_back_24x24.png" title="leftarrow"></a></td>';
        _tabCM += '<td align="right" >Page: </td>';
        _tabCM += '<td align="left" id="currentPageNumberCM" width="20"><b>' + pageNumber + '/' + numberOfPagesDisplay + '</b></td>';
        _tabCM += '<td id="rightarrow" align="right" width="16"><a href="javascript:toNextPage(&apos;' + tableId + '&apos;)"><img class="btnImg" src="icons/media_step_forward_24x24.png" title="rightarrow"></a></td>';
        _tabCM += '</tr>';
        _tabCM += '</table>';
        _tabCM += '</td>';
        _tabCM += '</tr>';
        _tabCM += '</table><br>';
        _tabCM += '<form name="formTableCM">';
        _tabCM += '<table style="width:100%; border: 1px solid white; border-collapse:separate; border-spacing: 0px 2px;" >';
        _tabCM += '<tr>';
        //_tabCM += '<td width="5"><b> </b></td>';
        _tabCM += '<td> <select class="active"  id="selectColumnsTableCoordinationModels"  multiple="multiple" title="Show/Hide columns" > </select> </td>';
         
        for (var i = 0; i <_tableCoordinationModelsDescription.length; i++) {

            if (!_tableCoordinationModelsDescription[i].Show) continue;
            var style_width = '';
            if (_tableCoordinationModelsDescription[i].Width != ''){
                style_width = 'style="min-width:' +_tableCoordinationModelsDescription[i].Width + 'px !important;"';
            }
            _tabCM += '<td ' + style_width + '><b>' + _tableCoordinationModelsDescription[i].ColumnTitle +'</b></td>';
        }
        
        _tabCM += '</tr>';

        //console.log("After _tabCM = ...");    
        _tabCM += generateSearchFieldsForMainTable(tableId);

        var classname;  // "odd" or "even"
        var m = firstLine;

        if (_numberOfPages != 0) {
            for (var i = firstLine; i <= lastLine; i++) {
                row_i = _rowNumbersToShow[i];
                j = row_i + 1;
                m++;
                if (_rowNumbersToShow.length == _cmList.length) {
                    numberDisplay = j;
                } else {
                    numberDisplay = m + '&nbsp;(' + j + ')';
                }
               // var toolTip = collectDataForCMToolTip(row_i);
                _tabCM += '<tr class="odd">';
                _tabCM += '<td width="5">' + numberDisplay + '</td>';

                for (var k = 0; k < _tableCoordinationModelsDescription.length; k++) {

                    if (!_tableCoordinationModelsDescription[k].Show) continue;
                    
                    var value =  _cmList[row_i][_tableCoordinationModelsDescription[k].Property];
                    
                  //  console.log("k: " + k + " prop:  " + _tableCoordinationModelsDescription[k].Property + " value " + value + "Descr: " + _tableCoordinationModelsDescription[k].Description)

                    if (_tableCoordinationModelsDescription[k].Description == "FirstColumnWithToolTip"){

                        var toolTipForCM = collectDataForTooltip(_tableCoordinationModelsDescription[k].Tooltip, _cmList[row_i]);

                        _tabCM += '<td><a class="classForTooltip"  title="" data-tooltip="' + toolTipForCM + '">' + value + '</a></td>';
                        var valueForFirstColumnWithToolTip = value;
                    }
                    if (_tableCoordinationModelsDescription[k].Description == "String"){

                        if (value === null || value === undefined || value.length === 0){
                            value = "-/-"
                        }
                        _tabCM += '<td>' + value + '</td>';
                    }
                    if (_tableCoordinationModelsDescription[k].Description == "DateWithTime"){

                        if (value === null || value === undefined || value.length === 0){
                            displayDate = "-/-"
                        }else{
                            // format date
                            date = value.replace('T', '  ');
                            displayDate = date.slice(0, 20);
                        }
                        _tabCM += '<td>' + displayDate + '</td>';
                    }
                    if (_tableCoordinationModelsDescription[k].Description == "SelectStatus") {

                        //TIMS EDITING
                        _tabCM += '<td>' + '<select name="CM_' + row_i + '" id="CM_' + row_i + '">';
                        for (var l = 0; l < coordinationModelReviewValuesFormatted.length; l++) {
                            _tabCM += '<option value=' + coordinationModelReviewValuesFormatted[l];
                            if (coordinationModelReviewValuesFormatted[l] == _cmList[row_i].status) {
                                _tabCM += ' selected>';
                            }
                            else {
                                _tabCM += '>';
                            }
                            _tabCM += coordinationModelReviewValuesFormatted[l] + '</option>';
                        }
                        _tabCM += '</select></td>';
                        //TIMS EDITING
                    }
                    if (_tableCoordinationModelsDescription[k].Description == "ButtonWriteComment"){

                        //TIMS EDITING
                        _tabCM += '<td align="center" ><a href="javascript:CMComment(' + row_i + ');"><img class="btnImg" src="icons/ballpen_64x64.png" width="48"  title="Write comment"></a></td>';
                        //_tabCM += '<td><input type ="button" value="Write Comment" onclick="CMComment(' + row_i + ');"></td>';
                        //TIMS EDITING
                    }
                    if (_tableCoordinationModelsDescription[k].Description == "ButtonSendStatus"){

                        //TIMS EDITING
                        _tabCM += '<td align="center" ><a href="javascript:updateDocumentCM(' + row_i + ');"><img class="btnImg" src="icons/mail_forward_64x64.png" width="48"  title="Send status and comment"></a></td>';
                        // _tabCM += '<td><input type ="button" value="Send Status" onclick="updateDocumentCM(' + row_i + ');"></td>';
                        //TIMS EDITING
                    }
                    if (_tableCoordinationModelsDescription[k].Description == "ButtonShowHidePartialModels"){
                        
                        if (_cmList[row_i].pmDocs !== undefined && _cmList[row_i].pmDocs !== null) {
                            _cmList_row_i_pmDocs_length = _cmList[row_i].pmDocs.length;
                        } else {
                            _cmList_row_i_pmDocs_length = "?";
                        }
                        _tabCM += '<td align="center" width="35" >' + '<button  class="iconbtn" type="button" onclick="showHidePartialModelsForCM(' + row_i + '); return false;" title="Show/Hide related '   + _template_partial +  ' models">';
                        _tabCM += '<span class="fa-stack" style="font-size:18px;  color:#99c33a; "> <span class="fa fa-circle fa-stack-2x"></span>';
                        _tabCM += '<strong class="fa-stack-1x" style="color:white;">' + _cmList_row_i_pmDocs_length + ' </strong> </span> </button> </td>';
                    }
                    //--
                    if (_tableCoordinationModelsDescription[k].Description == "ButtonViewPartialModels"){
                        
                       /*  if (_cmList[row_i].pmDocs !== undefined && _cmList[row_i].pmDocs !== null) {
                            _cmList_row_i_pmDocs_length = _cmList[row_i].pmDocs.length;
                        } else {
                            _cmList_row_i_pmDocs_length = "?";
                        } */
                        _tabCM += '<td align="center" width="100"><a href="javascript:viewPartialModelsForCM(' + row_i + ')"><img class="btnImg" src="icons/office_building_64x64.png" width="48"  title="View related '   + _template_partial +  ' models"></a></td>';

                        /* _tabCM += '<td align="center" width="35" >' + '<button  class="iconbtn" type="button" onclick="showHidePartialModelsForCM(' + row_i + '); return false;" title="View related partial models">';
                        _tabCM += '<span class="fa-stack" style="font-size:18px;  color:#99c33a; "> <span class="fa fa-circle fa-stack-2x"></span>';
                        _tabCM += '<strong class="fa-stack-1x" style="color:white;">' + _cmList_row_i_pmDocs_length + ' </strong> </span> </button> </td>';
                         */
                    }

                    if (_tableCoordinationModelsDescription[k].Description == "ButtonShowHideViewpointsForCM"){

                        if (_cmList[row_i].vpDocs !== undefined  && _cmList[row_i].vpDocs !== null) {
                            _cmList_row_i_vpDocs_length = _cmList[row_i].vpDocs.length;
                        } else {
                            _cmList_row_i_vpDocs_length = "?";
                        }
                        _tabCM += '<td align="center" width="35" >' + '<button  class="iconbtn" type="button" onclick="showHideViewpointsForCM(' + row_i + '); return false;" title="Show/Hide related viewpoints">';
                        _tabCM += '<span class="fa-stack" style="font-size:18px;  color:#99c33a; "> <span class="fa fa-circle fa-stack-2x"></span>';
                        _tabCM += '<strong class="fa-stack-1x" style="color:white;">' + _cmList_row_i_vpDocs_length + ' </strong> </span> </button> </td>';
                    }
                    if (_tableCoordinationModelsDescription[k].Description == "ButtonPostViewpointFromTableCM"){
                     
                        _tabCM += '<td align="center" width="100"><a href="javascript:sendVPtoTPWithCoordinationModelId(' + row_i + ')"><img class="btnImg" src="icons/compact_camera_64x64.png" width="48"  title="Post 3D View as viewpoint to tp and relate to this Model"></a></td>';
                    }
                }
                _tabCM += '</tr>';


                // Build subtable for patial models  

                //var wt = _tableCoordinationModels_SubtableViewpointsDescription.length + 1;
                var wt =  _tableCoordinationModelsDescription.length + 1;

                if (_cmList_row_i_pmDocs_length != "?" && _cmList_row_i_pmDocs_length != 0) {

                    var partialModelsMacroRowId = 'tabcmPmsMacroRow_' + row_i;
                    
                    _tabCM += '<tr id="tabcmPmsMacroRow_' + row_i + '"  style="display:none;">';
                    _tabCM += '<td colspan="' + wt +'">';
                    _tabCM += '<table style=" width: 100%; border: 1px solid white; border-collapse:separate; border-spacing: 0px 2px;">';
                    _tabCM += '<tr><td width="5">  </td></tr>';
                    _tabCM += '<tr id="pmsEmptyRow1_' + row_i + '">';
                    _tabCM += '<td align="left" colspan="50"><b> '   + _template_Partial +  ' Models related to Coordination Model &nbsp&apos;' + valueForFirstColumnWithToolTip  + '&apos; :</b></td>';
                    _tabCM += '</tr>';
                    _tabCM += '<tr><td width="5">  </td></tr>';
                    _tabCM += '<tr id="pmsTitleRow_' + row_i + '">';
                    _tabCM += '<td width="5"><b> &nbsp </b></td>';

                    for (var m = 0; m < _tableCoordinationModels_SubtablePartialModelsDescription.length; m++) {

                        if (!_tableCoordinationModels_SubtablePartialModelsDescription[m].Show) continue;

                        var style_width = '';
                        if ( _tableCoordinationModels_SubtablePartialModelsDescription[m].Width != ''){
                            style_width = 'style="min-width:' +  _tableCoordinationModels_SubtablePartialModelsDescription[m].Width + 'px !important;"';
                        }
                        _tabCM += '<td ' + style_width + '><b>' +  _tableCoordinationModels_SubtablePartialModelsDescription[m].ColumnTitle +'</b></td>';
                    }
                    _tabCM += '</tr>';

                    _tabCM += generateSearchFieldsForSubtable(partialModelsMacroRowId);
                    
                    for (var l = 0; l < _cmList[row_i].pmDocs.length; l++) {

                        //console.log('l: ' + l + ' partial model-Id: ' + _cmList[row_i].pmDocs[l].bim_doc_id);
                        //console.log(searchPartialModelWithId(_cmList[row_i].pmDocs[l].bim_doc_id));

                        _tabCM += '<tr id="pmRow_' + row_i + '_' + l + '" class="even" style="display:table-row;">';
                        _tabCM += '<td width="5"> &nbsp</td>';

                        if (_cmList[row_i].pmDocs[l].bim_doc_id !== null && _cmList[row_i].pmDocs[l].bim_doc_id !== undefined
                              && searchPartialModelWithId(_cmList[row_i].pmDocs[l].bim_doc_id) != null) {
                            
                           var viewpointsMacroRowIdForSubsubtable = 'tabCMsubtabpmSubsubtabVpsMacroRow_' + row_i + '_' + l;
                           var pm = JSON.parse(JSON.stringify(searchPartialModelWithId(_cmList[row_i].pmDocs[l].bim_doc_id)));
                           _tabCM += buildPieceOfRowForSubtablePM(pm, _tableCoordinationModels_SubtablePartialModelsDescription, viewpointsMacroRowIdForSubsubtable, pmNumRevVersObject);
                           _tabCM += '</tr>';
                              //console.log('pm:  ' + JSON.stringify(pm));
                            //-------------------------------------------------------------------------------
                           
                            // Bild subsubtable for Viewpoints of PM
                            
                            //var w = _tablePartialModelsDescription.length + 1;
                            var w1 = _tablePartialModels_SubtableViewpointsDescription.length + 1;
                            if (_viewpoints.loaded == true && pm.vpDocs !== null 
                                  && pm.vpDocs !== undefined && pm.vpDocs.length != 0) {
                   
                              _tabCM += '<tr id="' + viewpointsMacroRowIdForSubsubtable + '"  style="display:none;">';
                              _tabCM += '<td colspan="' + w1 +'">';
                              _tabCM += '<table style=" width: 100%; border: 1px solid white; border-collapse:separate; border-spacing: 0px 2px;">';
                              _tabCM += '<tr><td width="5">  </td></tr>';
                              _tabCM += '<tr id="subtabpmVpsEmptyRow1_' + row_i + '_' + l + '"  style="display:table-row;">';

                              for (var q = 0; q < _tableCoordinationModels_SubtablePartialModelsDescription.length; q++) {
                                  if (_tableCoordinationModels_SubtablePartialModelsDescription[q].Description == "FirstColumnWithToolTip"){
        
                                      var propValue =  pm[_tableCoordinationModels_SubtablePartialModelsDescription[q].Property];
                                       break;      
                                    }
                                }

                              _tabCM += '<td  align="left" colspan="50"><b>Viewpoints related to Partial Model &nbsp&apos;' + propValue + '&apos; :</b></td>';
                              _tabCM += '</tr>';
                              _tabCM += '<tr><td width="5"> &nbsp </td></tr>';
                              _tabCM += '<tr id="subtabpmVpsTitleRow_'  + row_i + '_' + l + '"  style="display:table-row;">';
                              _tabCM += '<td width="5"><b> </b></td>';

                              for (var t = 0; t <_tablePartialModels_SubtableViewpointsDescription.length; t++) {

                                if (!_tablePartialModels_SubtableViewpointsDescription[t].Show) continue;
                                 var style_width1 = '';
                                  /*
                                  if (_tablePartialModels_SubtableViewpointsDescription[t].Width != ''){
                                     style_width1 = 'style="min-width:' +_tablePartialModels_SubtableViewpointsDescription[t].Width + 'px !important;"';
                                   }
                                   */
                                   _tabCM += '<td ' + style_width1 + '><b>' + _tablePartialModels_SubtableViewpointsDescription[t].ColumnTitle +'</b></td>';
                                }
                                _tabCM += '</tr>';

                                _tabCM += generateSearchFieldsForSubtable(viewpointsMacroRowIdForSubsubtable);

                                for (var z = 0; z < pm.vpDocs.length; z++) {

                                //console.log('l: ' + l + ' Viewpoint-Id: ' + _pmList[row_i].vpDocs[l].bim_doc_id);
                                //console.log('_pmList[row_i].vpDocs[l].name: ' + _pmList[row_i].vpDocs[l].name);
                    
                                var vp_number1 = _viewpoints.idsAndNumbers[pm.vpDocs[z].bim_doc_id];
                               //console.log('----> vp_number: ' + vp_number);

                               _tabCM += '<tr id="vpRow_' + row_i + '_' + l +  '_' + z + '" class="ededed" style="display:table-row;">';
                               _tabCM += '<td width="5"> &nbsp </td>';
                               _tabCM += buildPieceOfRowForTableVP(vp_number1, _tablePartialModels_SubtableViewpointsDescription);
                               _tabCM += '</tr>';
                            }
                            _tabCM += '<tr id="subtabpmVpsEmptyRow2_' + row_i + '_' + l +'"  style="display:table-row;"><td width="5"><b>&nbsp</b></td></tr>';
                            _tabCM += '</table>';
                            _tabCM += '</td>';
                            _tabCM += '</tr>';
                        }
                     
                        } else {
                           var text =  'Filename: : ' + _cmList[row_i].pmDocs[l].pmFilename;
                           text +=   '  /  Id: ' +  _cmList[row_i].pmDocs[l].bim_doc_id + '  (Data are not found!)';
                           _tabCM += '<td align="left" colspan="' + _tableCoordinationModels_SubtablePartialModelsDescription.length +'">' + text + '</td>';
                           _tabCM += '</tr>';
                        }
                    }
                    _tabCM += '<tr id="pmsEmptyRow2_' + row_i + '"  style="display:table-row;"><td width="5"><b>&nbsp </b></td></tr>';
                    _tabCM += '</table>';
                    _tabCM += '</td>';
                    _tabCM += '</tr>';
                }


                // Build subtable for viewpoints  

                var wt = _tableCoordinationModels_SubtableViewpointsDescription.length + 2;
                if (_cmList_row_i_vpDocs_length != "?" && _cmList_row_i_vpDocs_length != 0) {
                   
                    var viewpointsMacroRowIdForCM = 'tabcmVpsMacroRow_'+ row_i;
                    _tabCM += '<tr id="tabcmVpsMacroRow_' + row_i + '"  style="display:none;">';
                    _tabCM += '<td colspan="' + wt +'">';
                    _tabCM += '<table style=" width: 100%; border: 1px solid white; border-collapse:separate; border-spacing: 0px 2px;">';
                    _tabCM += '<tr><td width="5">  </td></tr>';
                    _tabCM += '<tr id="vpsEmptyRow1_' + row_i + '">';
                    _tabCM += '<td align="left" colspan="50"><b>Viewpoints related to Coordination Model &nbsp&apos;' + valueForFirstColumnWithToolTip + '&apos; :</b></td>';
                    _tabCM += '</tr>';
                    _tabCM += '<tr><td width="5"> &nbsp  </td></tr>';
                    _tabCM += '<tr id="vpsTitleRow_' + row_i + '">';
                    _tabCM += '<td width="5"><b> &nbsp </b></td>';
                    for (var t = 0; t <_tableCoordinationModels_SubtableViewpointsDescription.length; t++) {

                        if (!_tableCoordinationModels_SubtableViewpointsDescription[t].Show) continue;
                        var style_width = '';
                        /*
                        if (_tableCoordinationModels_SubtableViewpointsDescription[t].Width != ''){
                            style_width = 'style="min-width:' +_tableCoordinationModels_SubtableViewpointsDescription[t].Width + 'px !important;"';
                        }
                        */
                        _tabCM += '<td ' + style_width + '><b>' + _tableCoordinationModels_SubtableViewpointsDescription[t].ColumnTitle +'</b></td>';
                    }
                    _tabCM += '</tr>';

                    _tabCM += generateSearchFieldsForSubtable(viewpointsMacroRowIdForCM);

                    for (var l = 0; l < _cmList[row_i].vpDocs.length; l++) {

                        //console.log('l: ' + l + ' Viewpoint-Id: ' + _cmList[row_i].vpDocs[l].bim_doc_id);
                        //console.log('_cmList[row_i].vpDocs[l].name: ' + _cmList[row_i].vpDocs[l].name);

                        var vp_number = searchViewpointWithId(_cmList[row_i].vpDocs[l].bim_doc_id);
                        //console.log('----> vp_number: ' + vp_number);
                        if (vp_number === undefined) {
                            
                            var text =  'Name: ' + _cmList[row_i].vpDocs[l].name;
                            text +=   '  /  Id: ' +  _cmList[row_i].vpDocs[l].bim_doc_id + '  (Data are not found!)';
                            _tabCM += '<tr id="vpRow_' + row_i + '_' + l + '" class="ededed" style="display:table-row;">';
                            _tabCM += '<td width="5"> &nbsp</td>';
                            _tabCM += '<td align="left" colspan="' + _tableCoordinationModels_SubtableViewpointsDescription.length +'">' + text + '</td>';
                            _tabCM += '</tr>';
                           
                        } else {
                            
                            _tabCM += '<tr id="vpRow_' + row_i + '_' + l + '" class="ededed" style="display:table-row;">';
                            _tabCM += '<td width="5"> &nbsp</td>';
                            _tabCM += buildPieceOfRowForTableVP(vp_number, _tableCoordinationModels_SubtableViewpointsDescription);
                            _tabCM += '</tr>';

                        }
                    }
                    _tabCM += '<tr id="vpsEmptyRow2_' + row_i + '"  style="display:table-row;"><td width="5"><b>&nbsp </b></td></tr>';
                    _tabCM += '</table>';
                    _tabCM += '</td>';
                    _tabCM += '</tr>';
                }
            }
        }
        _tabCM += '</table></form>';
        _tblCM.innerHTML = _tabCM;
    }

    


    var options = buildOptionsForSelectColumns(_displayedTable.type);
    //console.log(JSON.stringify(options));
   /*  options = [{
        name   : 'Option Name 1',
        value  : 'option-value-1',
        checked: false,
        attributes : {
            custom1: 'value1',
            custom2: 'value2'
        }
    },{
        name   : 'Option Name 2',
        value  : 'option-value-2',
        checked: false,
        attributes : {
            custom1: 'value1',
            custom2: 'value2'
        }
    }] */
             
    $('.active').multiselect({
        columns  : 3,
        search   : true,
        selectAll: false,
        checkboxAutoFit: true,
        selectGroup: true,
        maxPlaceholderOpts : null,
        texts : {
            placeholder: 'Columns',
            selectedOptions: ''
        },
        onControlClose: function(element) {
            var thisVals = $(element).val();
            // console.log(thisVals.length);
            // console.log(JSON.stringify(thisVals));
            onSelectColumnsClosed(_displayedTable.type, options, thisVals);
        }
    });
    $('.active').multiselect('loadOptions', options);
};



function buildOptionsForSelectColumns(displayedTableType){

   // console.log(displayedTableType);
    var option = {};

    if (displayedTableType == "VPC"){
        var options = [];
        for (var i = 0; i <_tableViewpointsDescription.length; i++) {

            if (_tableViewpointsDescription[i].Description != "FirstColumnWithToolTip" && 
                       _tableViewpointsDescription[i].Description.indexOf("Button") == -1 ){
                option = {};
                option.name = _tableViewpointsDescription[i].ColumnTitle;
                option.value = _tableViewpointsDescription[i].ColumnTitle;
                option.checked = _tableViewpointsDescription[i].Show
                options.push(option);
            }
        }
        return options;                
    }
    if (displayedTableType == "PMC"){
        var groups = [
               {
                 label  : "Table 'Partial Models'",
                 options: []
               },
               {
                  label  : "Subtable 'Viewpoints'",
                  options: []
               }
            ];
        groups[0].label = "Table '" +  _template_Partial +  " Models'";
        for (var i = 0; i < _tablePartialModelsDescription.length; i++) {

            if (_tablePartialModelsDescription[i].Description != "FirstColumnWithToolTip" &&
                _tablePartialModelsDescription[i].Description.indexOf("Button") == -1 &&
                _tablePartialModelsDescription[i].Description.indexOf("Select") == -1) {
                option = {};
                option.name = _tablePartialModelsDescription[i].ColumnTitle;
                option.value = "PM##" + _tablePartialModelsDescription[i].ColumnTitle;
                option.checked = _tablePartialModelsDescription[i].Show
                groups[0].options.push(option);
            }
        }
        for (var i = 0; i < _tablePartialModels_SubtableViewpointsDescription.length; i++) {

            if (_tablePartialModels_SubtableViewpointsDescription[i].Description != "FirstColumnWithToolTip" &&
                _tablePartialModels_SubtableViewpointsDescription[i].Description.indexOf("Button") == -1) {
                option = {};
                option.name = _tablePartialModels_SubtableViewpointsDescription[i].ColumnTitle;
                option.value = "VP##" + _tablePartialModels_SubtableViewpointsDescription[i].ColumnTitle;
                option.checked = _tablePartialModels_SubtableViewpointsDescription[i].Show
                groups[1].options.push(option);
            }
        }  
        return groups;
    }
    if (displayedTableType == "CMC"){
        var groups = [
               {
                 label  : "Table 'Coordination Models'",
                 options: []
               },
               {
                  label  : "Subtable 'Partial Models'",
                  options: []
               },
               {
                label  : "Subtable 'Viewpoints'",
                options: []
             },
            ];
        
        groups[1].label = "Subtable '" +  _template_Partial +  " Models'";
        for (var i = 0; i < _tableCoordinationModelsDescription.length; i++) {

            if (_tableCoordinationModelsDescription[i].Description != "FirstColumnWithToolTip" &&
                _tableCoordinationModelsDescription[i].Description.indexOf("Button") == -1 &&
                _tableCoordinationModelsDescription[i].Description.indexOf("Select") == -1) {
                option = {};
                option.name = _tableCoordinationModelsDescription[i].ColumnTitle;
                option.value = "CM##" + _tableCoordinationModelsDescription[i].ColumnTitle;
                option.checked = _tableCoordinationModelsDescription[i].Show
                groups[0].options.push(option);
            }
        }
        for (var i = 0; i <  _tableCoordinationModels_SubtablePartialModelsDescription.length; i++) {

            if ( _tableCoordinationModels_SubtablePartialModelsDescription[i].Description != "FirstColumnWithToolTip" &&
                 _tableCoordinationModels_SubtablePartialModelsDescription[i].Description.indexOf("Button") == -1 &&
                 _tableCoordinationModels_SubtablePartialModelsDescription[i].Description.indexOf("Select") == -1) {
                option = {};
                option.name =  _tableCoordinationModels_SubtablePartialModelsDescription[i].ColumnTitle;
                option.value = "PM##" +  _tableCoordinationModels_SubtablePartialModelsDescription[i].ColumnTitle;
                option.checked =  _tableCoordinationModels_SubtablePartialModelsDescription[i].Show
                groups[1].options.push(option);
            }
        }
        for (var i = 0; i <  _tableCoordinationModels_SubtableViewpointsDescription.length; i++) {

            if ( _tableCoordinationModels_SubtableViewpointsDescription[i].Description != "FirstColumnWithToolTip" &&
                 _tableCoordinationModels_SubtableViewpointsDescription[i].Description.indexOf("Button") == -1) {
                option = {};
                option.name =  _tableCoordinationModels_SubtableViewpointsDescription[i].ColumnTitle;
                option.value = "VP##" +  _tableCoordinationModels_SubtableViewpointsDescription[i].ColumnTitle;
                option.checked =  _tableCoordinationModels_SubtableViewpointsDescription[i].Show
                groups[2].options.push(option);
            }
        }  
        
        return groups;
    }
}


function onSelectColumnsClosed(displayedTableType, options, values){
   
    console.log(displayedTableType);
    if (displayedTableType == "VPC"){
        for (var i = 0; i <_tableViewpointsDescription.length; i++) {
            if (_tableViewpointsDescription[i].Description != "FirstColumnWithToolTip" && 
                       _tableViewpointsDescription[i].Description.indexOf("Button") == -1 ){
                if (values.indexOf(_tableViewpointsDescription[i].ColumnTitle) != -1){
                    _tableViewpointsDescription[i].Show = true;
                }else{
                    _tableViewpointsDescription[i].Show = false;
                }
            }
        }   
        rewriteConfigFile();
        showViewpoints();
    }

    if (displayedTableType == "PMC"){
        for (var i = 0; i < _tablePartialModelsDescription.length; i++) {
            if (_tablePartialModelsDescription[i].Description != "FirstColumnWithToolTip" &&
                _tablePartialModelsDescription[i].Description.indexOf("Button") == -1 &&
                _tablePartialModelsDescription[i].Description.indexOf("Select") == -1) {
                   if (values.indexOf("PM##" + _tablePartialModelsDescription[i].ColumnTitle) != -1){
                      _tablePartialModelsDescription[i].Show = true;
                    }else{
                      _tablePartialModelsDescription[i].Show = false;
                    }
            }
        } 
        for (var i = 0; i < _tablePartialModels_SubtableViewpointsDescription.length; i++) {
            if(_tablePartialModels_SubtableViewpointsDescription[i].Description != "FirstColumnWithToolTip" &&
               _tablePartialModels_SubtableViewpointsDescription[i].Description.indexOf("Button") == -1){
                if (values.indexOf("VP##" + _tablePartialModels_SubtableViewpointsDescription[i].ColumnTitle) != -1){
                    _tablePartialModels_SubtableViewpointsDescription[i].Show = true;
                }else{
                    _tablePartialModels_SubtableViewpointsDescription[i].Show = false;
                }
            }
            
        }
        rewriteConfigFile();
        showPartialModels(_displayedTable.filter);
    }

    if (displayedTableType == "CMC"){
        for (var i = 0; i < _tableCoordinationModelsDescription.length; i++) {
            if(_tableCoordinationModelsDescription[i].Description != "FirstColumnWithToolTip" &&
               _tableCoordinationModelsDescription[i].Description.indexOf("Button") == -1 &&
               _tableCoordinationModelsDescription[i].Description.indexOf("Select") == -1){
                if (values.indexOf("CM##" + _tableCoordinationModelsDescription[i].ColumnTitle) != -1){
                    _tableCoordinationModelsDescription[i].Show = true;
                }else{
                    _tableCoordinationModelsDescription[i].Show = false;
                }
            }
        } 
        for (var i = 0; i <  _tableCoordinationModels_SubtablePartialModelsDescription.length; i++) {
            if(_tableCoordinationModels_SubtablePartialModelsDescription[i].Description != "FirstColumnWithToolTip" &&
               _tableCoordinationModels_SubtablePartialModelsDescription[i].Description.indexOf("Button") == -1 &&
               _tableCoordinationModels_SubtablePartialModelsDescription[i].Description.indexOf("Select") == -1){
                if (values.indexOf("PM##" + _tableCoordinationModels_SubtablePartialModelsDescription[i].ColumnTitle) != -1){
                    _tableCoordinationModels_SubtablePartialModelsDescription[i].Show = true;
                }else{
                    _tableCoordinationModels_SubtablePartialModelsDescription[i].Show = false;
                }
            }
        }
        for (var i = 0; i < _tableCoordinationModels_SubtableViewpointsDescription.length; i++) {
            if(_tableCoordinationModels_SubtableViewpointsDescription[i].Description != "FirstColumnWithToolTip" &&
               _tableCoordinationModels_SubtableViewpointsDescription[i].Description.indexOf("Button") == -1){
                if (values.indexOf("VP##" + _tableCoordinationModels_SubtableViewpointsDescription[i].ColumnTitle) != -1){
                    _tableCoordinationModels_SubtableViewpointsDescription[i].Show = true;
                }else{
                    _tableCoordinationModels_SubtableViewpointsDescription[i].Show = false;
                }
            }
        }
        rewriteConfigFile();
        showCoordinationModels(_displayedTable.filter);

    }

    function rewriteConfigFile(){
        var configObject = {projects : __projects__};
        var returns = desiteAPI.writeFile(_tp_configFilePath, JSON.stringify(configObject), "UTF-8");
        console.log("New configuration is written to file: " + _tp_configFilePath + "     returns: " + returns);
    }

    
}

async function viewPartialModelsForCM(row_i){

    for (var tpColonPropName in _config.ProjectDescription.PartialModels.PropertiesForTransferToDESITE){
        var prop = _config.ProjectDescription.PartialModels.PropertiesForTransferToDESITE[tpColonPropName];
        if (prop == "bim_doc_id"){
            var tpColonNameForBIM_DOC_ID =  tpColonPropName; 
            break;       
        }
    }
    
    var DESITE_project_props = await desiteAPI.getPropertyTypeList("all", tpColonNameForBIM_DOC_ID);
    console.log(JSON.stringify(DESITE_project_props));
    if(DESITE_project_props.length == 0){
        alert("No models with property '" + tpColonNameForBIM_DOC_ID + "' are found in DESITE Project. Please import your " + _template_partial + " models to the Project!" )
        return
    };
    var  modelListInDesiteProject = await desiteAPI.getModelListByDomain("geometry");
    if (_cmList[row_i].pmDocs !== undefined && _cmList[row_i].pmDocs !== null) {

       var  _cmList_row_i_pmDocs_length = _cmList[row_i].pmDocs.length;

        if (_cmList_row_i_pmDocs_length != "?" && _cmList_row_i_pmDocs_length != 0) {

            await desiteAPI.hideAll(true);
            
            for (var l = 0; l < _cmList[row_i].pmDocs.length; l++) {

                //console.log('l: ' + l + ' partial model-Id: ' + _cmList[row_i].pmDocs[l].bim_doc_id);
                //console.log(searchPartialModelWithId(_cmList[row_i].pmDocs[l].bim_doc_id));
              
                if (_cmList[row_i].pmDocs[l].bim_doc_id !== null && _cmList[row_i].pmDocs[l].bim_doc_id !== undefined
                      && searchPartialModelWithId(_cmList[row_i].pmDocs[l].bim_doc_id) != null) {
                      
                        // pm = JSON.parse(JSON.stringify(searchPartialModelWithId(_cmList[row_i].pmDocs[l].bim_doc_id)));
                        //var modelFilename = pm.pmFilename;
                        var bim_doc_id = _cmList[row_i].pmDocs[l].bim_doc_id
                        var bim_doc_id_splitting = bim_doc_id.split("-");
                        var bim_doc_number = bim_doc_id_splitting[0] + "-" + bim_doc_id_splitting[1];
                        var  desiteModelId = '';
                        var found = false;
                        for (var m = 0; m < modelListInDesiteProject.length; m++){
                            //console.log(m);
                            var DESITE_modelId = modelListInDesiteProject[m];
                            var rootNodeId = await desiteAPI.getRootNodeByModel(DESITE_modelId);
                            var tp_modelId =  await desiteAPI.getPropertyValue(rootNodeId, tpColonNameForBIM_DOC_ID, 'xs:string');
                            //console.log("bim_doc_id_PropertyName: " + bim_doc_id_PropertyName + "   tp_modelId: " + tp_modelId);

                            if (tp_modelId.indexOf(bim_doc_number) == 0){
                                var elements = await desiteAPI.getContainedElements(rootNodeId, 0);
                                await desiteAPI.showElements(rootNodeId);
                                await desiteAPI.showElements(await desiteAPI.idListToStr(elements));
                                found = true;
                                break;
                            }
                        }
                        if (!found){
                            alert(_template_Partial +' model with BIM_DOC_NUMBER: ' + bim_doc_number + ' is not found in the DESITE Project. Please import your models!');
                        
                        }
                }
            }
            await desiteAPI.zoomToVisible();
        }

    } else {
        return;
    } 

    
}

async function showHomeViewpoint(){
      
    var homeViewpointId = '';
    desiteAPI.itClear();
    var numberOfViewpoints = await desiteAPI.itByFilter('Type', 'xs:string', 'Viewpoint', false, 'issues');
    var numberOfObjectsFound = await desiteAPI.itByFilter('IsHomeViewpoint', 'xs:boolean', 'true', false, 'issues');
    if (numberOfObjectsFound == 1){         
        homeViewpointId =  (await desiteAPI.strToIdList(await desiteAPI.itGetObjectList()))[0];
        await desiteAPI.showViewpointByID(homeViewpointId);
    }
}

function showInformation(){
      
    $( "#dialogInformation" ).dialog("open");
}
